import pygame
from model import *
from agent import Agent
from world import World


def pause(win, myfont20, fpsClock):
    """
    space键按下后执行暂停功能
    """
    is_pause = True
    while is_pause:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                quit()
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:  # Esc键 退出游戏
                    pygame.quit()
                    exit()
                if event.key == pygame.K_SPACE: # 再次按空格键继续游戏
                    is_pause = False
        text_image_pause = myfont20.render(
            "Press SPACE to countinue",  True,  WHITE)
        win.blit(text_image_pause, (WINDOWS_W/2-100, WINDOWS_H/2-10))  
        pygame.display.update()
        fpsClock.tick(5)


if __name__ == "__main__":
    pygame.init()
    fpsClock = pygame.time.Clock()
    win = pygame.display.set_mode((WINDOWS_W, WINDOWS_H), 0, 32)
    pygame.display.set_caption('possession')
    myfont20 = pygame.font.SysFont("Arial", 20)
    world = World()
    # 两个agent
    agent1 = Agent(  img='ball.png',
                     size=(40, 40),
                     v_drct=Vector2(1, 1).normalize(),
                     v_norm=4.5,
                     a_drct=Vector2(1, 1).normalize(),
                     a_norm=0,
                     m=1,
                     init_pos=(WINDOWS_W/2, WINDOWS_H/2),
                     id=1)
    agent2 = Agent(  img='attacker.png',
                     size=(40, 40),
                     v_drct=Vector2(1, 1).normalize(),
                     v_norm=4.5,
                     a_drct=Vector2(1, 1).normalize(),
                     a_norm=0,
                     m=1,
                     init_pos=(150, 150),
                     id=2)
    world.add_agent(agent1)
    world.add_agent(agent2)
    agent1.init_intent(world=world)
    agent2.init_intent(world=world)
    agent_list = pygame.sprite.Group()
    agent_list.add(agent1)
    agent_list.add(agent2)
    # treasure = Treasure(init_position=(120, 130), id=3)
    treasure = Treasure(init_position=(WINDOWS_W/2, WINDOWS_H/2-1), id=3)
    treasure.init_world(world)
    world.add_object(treasure)
    treasure_list = pygame.sprite.Group()
    treasure_list.add(treasure)
    # mouse_pos = Vector2(WINDOWS_W/2, WINDOWS_H/2)

    world.init_treasure()

    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                exit()
            elif event.type == pygame.MOUSEBUTTONDOWN:
                mouse_pos = Vector2(event.pos) # 获取鼠标的向量
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:  # Esc键 退出游戏
                    pygame.quit()
                    exit()
                if event.key == pygame.K_SPACE:   # 空格键 暂停
                    pause(win, myfont20, fpsClock)
        if pygame.sprite.collide_circle(agent1, agent2):
            agent1.be_bounced()
            agent2.be_bounced()
            agent1.bounce(agent2)
        agent_list.update()
        treasure_list.update()
        win.fill(BLACK)
        # pygame.display.update() # 让绘制的图片出现在屏幕上
        agent_list.draw(win)
        treasure_list.draw(win)
        pygame.display.flip()
        fpsClock.tick(FPS)