import pygame
from pygame.math import Vector2
from const import *
from agent import Agent
import numpy as np


# class Processor(Agent):
#     def __init__(self):
#         super().__init__(img='ball.png',
#                          size=(40, 40),
#                          v_drct=Vector2(1, 1).normalize(),
#                          v_norm=4.5,
#                          a_drct=Vector2(1, 1).normalize(),
#                          a_norm=0,
#                          m=1,
#                          init_pos=(WINDOWS_W/2, WINDOWS_H/2))
#
#     def update(self):
#         super().collision_detection()
#         super().ahead()
#         return super().update()
#
#
# class Attacker(Agent):
#     def __init__(self, potential_treasure):
#         super().__init__(img='attacker.png',
#                          size=(40, 40),
#                          v_drct=Vector2(1, 1).normalize(),
#                          v_norm=4.5,
#                          a_drct=Vector2(1, 1).normalize(),
#                          a_norm=0,
#                          m=1000,
#                          init_pos=(50, 50)
#                          )
#
#
#     def update(self, dest):
#         self.toward_v(dest)
#         super().collision_detection()
#         super().ahead()
#         self.carryTreasure()
#         return super().update()

class Treasure(pygame.sprite.Sprite):
    def __init__(self, init_position=(WINDOWS_W/2, WINDOWS_H/2), id=None, size=(40, 40)) -> None:
        pygame.sprite.Sprite.__init__(self)
        player_img = pygame.image.load("treasure.png").convert()
        self.image = pygame.transform.scale(player_img, (20,20))
        self.image.set_colorkey(WHITE)
        self.rect = self.image.get_rect()
        self.rect.center = init_position
        self.being_held_id = None
        self.id = id
        self.size = size

    def update(self) -> None:
        if self.being_held_id is not None:
            helder = self.world.retrieve_by_id(self.being_held_id)
            self.rect.center = helder.get_position()
        return super().update()

    def get_position(self):
        return self.rect.center

    def init_world(self, world):
        self.world = world
