import pygame
import math

# 一些常用的函数
DEFEND_RADIUS = 50
SAFE_DISTANCE = 60


def near_distance(target1, target2):
    return math.sqrt((target1.size[0]/2 + target2.size[0]/2)**2 + (target1.size[1]/2 + target2.size[1]/2)**2)


def distance(target1, target2):
    if isinstance(target1, pygame.sprite.Sprite):
        pos1 = target1.get_position()
    else:
        pos1 = target1
    if isinstance(target2, pygame.sprite.Sprite):
        pos2 = target2.get_position()
    else:
        pos2 = target2
    return math.sqrt((pos1[0] - pos2[0])**2 + (pos1[1] - pos2[1])**2)


def is_near(target1, target2):
    return distance(target1, target2) < near_distance(target1, target2)


# 从target2到target1
def get_norm_direction(target1, target2):
    direction = (target1.get_position()[0] - target2.get_position()[0], target1.get_position()[1] - target2.get_position()[1])
    norm_direction = (direction[0] / math.sqrt(direction[0] ** 2 + direction[1] ** 2), direction[1] / math.sqrt(direction[0] ** 2 + direction[1] ** 2))
    return norm_direction


def get_direction(target1, target2):
    direction = (target1.get_position()[0] - target2.get_position()[0], target1.get_position()[1] - target2.get_position()[1])
    return direction


from agent import Agent
